use futures::{AsyncReadExt, StreamExt};
use miette::IntoDiagnostic;

async fn handle(stream: smol::io::Result<smol::net::TcpStream>) -> smol::io::Result<()> {
    let (reader, mut writer) = stream?.split();
    futures::io::copy(reader, &mut writer).await.map(|_| {})
}

fn main() -> miette::Result<()> {
    smol::block_on(async {
        smol::net::TcpListener::bind("0.0.0.0:42042")
            .await
            .into_diagnostic()?
            .incoming()
            .for_each_concurrent(None, |stream| async {
                if let Err(e) = handle(stream).await.into_diagnostic() {
                    eprintln!("{e}");
                }
            })
            .await;
        Ok(())
    })
}
